# -*- coding: utf-8 -*-
from fileinput import filename
import sys
import glob
from tracemalloc import start
from PyQt5.QtWidgets import *
from PyQt5 import uic, QtCore, QtGui, QtWidgets
import os
import time
from PyQt5.QtGui import *
from random import randint

form_class = uic.loadUiType("baseBallGame.ui")[0]

class MyWindow(QMainWindow, form_class):
    def __init__(self):
        global tries

        super().__init__()

        # self.setFixedSize(570,582)
        # self.setWindowIcon(QIcon("pagichacha.png"))
        self.setupUi(self)

        self.pushButton.clicked.connect(self.newStart)
        # self.toolButton_3.clicked.connect(self.keywordSelectFile)
        # self.toolButton.clicked.connect(self.selectFolder)
        # self.toolButton_2.clicked.connect(self.selectSaveFile)
        self.pushButton_2.clicked.connect(self.continue_)
        

    def newStart(self):
        global mine, tries, ANSWER, start

        start = time.time()
        print("게임이 처음으로 시작되어 컴퓨터가 번호를 새롭게 생성합니다.")

        ##################################################################
        # 1. 컴퓨터가 생성한 정답 스트라이크 숫자
        ##################################################################
        numbers = []

        while len(numbers) < 3:
            new_number = randint(0,9)
            if new_number not in numbers:
                numbers.append(new_number)
        ANSWER = numbers
        print("컴퓨터가 생성한 스트라이크 숫자 : ", ANSWER)

        tries = 0
        ##################################################################
        # 2. 내가 입력한 스트라이크 숫자
        ##################################################################

        if self.lineEdit.text():
            userInput = self.lineEdit.text()
            userInput = userInput.strip()

            newuserInput = userInput.split(',')
            print(newuserInput)
            self.textEdit.clear()

            mine = []

            for n in newuserInput:
                n = n.strip()
                if n.isdigit() != True or (int(n) < 0 or int(n) > 9):
                    print("0에서 9까지의 수를 입력해 주세요.")
                    self.textEdit.append("0에서 9까지의 수를 입력해 주세요.")
                    break
                elif int(n) in mine:
                    print("중복되는 숫자입니다. 다시 입력하세요.")
                    self.textEdit.append("중복되는 숫자입니다. 다시 입력하세요.")
                    break
                else:
                    mine.append(int(n))

            # self.textEdit.clear()
            print(mine)
            self.textEdit.append("내가 입력한 스트라이크 숫자: "+str(mine))

            if len(mine) == 3:
                ##################################################################
                # 3. 컴퓨터의 스트라이크 숫자와 내가 입력한 숫자를 비교
                ##################################################################
                strike_count = 0
                ball_count = 0

                for i in range(3):
                    if mine[i] == ANSWER[i]:
                        strike_count += 1
                    elif mine[i] in ANSWER:
                        ball_count += 1
                s, b = strike_count, ball_count

                tries += 1

                if s == 3:
                    self.textEdit.append("컴퓨터가 생성한 스트라이크 숫자 : "+ str(ANSWER))
                    print("\n축하합니다.!! ",s," 스트라이크로 모두 맞추셨습니다.\n")
                    self.textEdit.append("\n축하합니다.!! "+str(tries)+" 번만에 "+str(s)+" 스트라이크를 모두 맞추셨습니다.\n")
                    end = time.time()
                    et = end - start
                    et = format(et, ".2f")
                    print("타자 시간 :", et, " 초")
                    
                else:
                    print("\n아쉽습니다.!! ",s," 스트라이크 ", b, " 볼 입니다.\n")
                    self.textEdit.append("\n아쉽습니다.!! "+str(s)+" 스트라이크 "+str(b)+" 볼 입니다. "+str(tries)+" 번째 시도 하셨습니다.\n")
            else:
                print("0~9까지의 올바른 3개의 숫자를 입력하여 주시기 바랍니다.")
                self.textEdit.append("\n\n#########################################################################################")
                self.textEdit.append("0~9까지의 올바른 3개의 숫자를 입력하여 주시기 바랍니다.")
                self.textEdit.append("예: 중복된 숫자 입력 불가, 문자입력 불가, 3개가 아닌 2개, 4개 등 숫자 개수가 틀린 입력 불가 등")
                self.textEdit.append("#########################################################################################")
        else:
            self.textEdit.setText("0에서 9까지의 수를, (콤마)로 구분하여 3개 입력해 주세요!\n예: 1,2,3")



    def continue_(self):
        global mine, tries, ANSWER, start

        print("게임이 이미 시작되어 컴퓨터가 번호를 새롭게 생성하지 않습니다.")

        try:
            ##################################################################
            # 2. 내가 입력한 스트라이크 숫자
            ##################################################################
            if self.lineEdit.text():
                userInput = self.lineEdit.text()
                userInput = userInput.strip()

                newuserInput = userInput.split(',')
                print(newuserInput)
                self.textEdit.clear()

                mine = []

                for n in newuserInput:
                    n = n.strip()
                    if n.isdigit() != True or (int(n) < 0 or int(n) > 9):
                        print("0에서 9까지의 수를 입력해 주세요!")
                        self.textEdit.append("0에서 9까지의 수를 입력해 주세요.")
                        break
                    elif int(n) in mine:
                        print("중복되는 숫자입니다. 다시 입력하세요.")
                        self.textEdit.append("중복되는 숫자입니다. 다시 입력하세요.")
                        break
                    else:
                        mine.append(int(n))

                self.textEdit.clear()
                print(mine)
                self.textEdit.append("내가 입력한 스트라이크 숫자 : "+str(mine))

                if len(mine) == 3:
                    ##################################################################
                    # 3. 컴퓨터의 스트라이크 숫자와 내가 입력한 숫자를 비교
                    ##################################################################
                    strike_count = 0
                    ball_count = 0

                    for i in range(3):
                        if mine[i] == ANSWER[i]:
                            strike_count += 1
                        elif mine[i] in ANSWER:
                            ball_count += 1
                    s, b = strike_count, ball_count
                    tries += 1

                    if s == 3:
                        self.textEdit.append("컴퓨터가 생성한 스트라이크 숫자 : "+str(ANSWER))
                        print("\n축하합니다.!! ",s," 스트라이크로 모두 맞추셨습니다.\n")
                        self.textEdit.append("\n축하합니다.!! "+str(tries)+" 번 만에 "+str(s)+" 스트라이크를 모두 맞추셨습니다.\n")
                        end = time.time()
                        et = end - start
                        et = format(et, ".2f")
                        print("타자 시간 : ", et, " 초")
                        self.textEdit.append("걸린 시간 : "+str(et)+" 초\n")
                    else:
                        print("\n아쉽습니다.!! ",s," 스트라이크 ", b, " 볼 입니다.\n")
                        self.textEdit.append("\n아쉽습니다.!! "+str(s)+" 스트라이크 "+str(b)+" 볼 입니다. "+str(tries)+" 번째 시도 하셨습니다.")
                else:
                    print("0~9까지의 올바른 3개의 숫자를 입력하여 주시기 바랍니다.")
                    self.textEdit.append("\n\n#########################################################################################")
                    self.textEdit.append("0~9까지의 올바른 3개의 숫자를 입력하여 주시기 바랍니다.")
                    self.textEdit.append("예: 중복된 숫자 입력 불가, 문자입력 불가, 3개가 아닌 2개, 4개 등 숫자 개수가 틀린 입력 불가 등")
                    self.textEdit.append("\n\n#########################################################################################")
            else:
                self.textEdit.setText("0에서 9까지의 수를, (콤마)로 구분하여 3개 입력해 주세요!\n예: 1,2,3")

        except:
            print("처음 시작인 경우 먼저 '새로시작' 버튼을 클릭해 주세요.")
            self.textEdit.append("\n\n#########################################################################################")
            self.textEdit.append("처음 시작인 경우 먼저 '새로시작' 버튼을 클릭해 주세요.")
            self.textEdit.append("\n\n#########################################################################################")


if __name__ == '__main__':
    app=QApplication(sys.argv)
    window = MyWindow()
    window.show()
    print("Before event loop")
    app.exec_()
    print("After event loop")